package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckLeaveFactoryResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckLeaveFactoryResultMapper extends IBaseMapper<TmstruckLeaveFactoryResult, BigDecimal> {
    //查询最大ID
    @Select("select seq_tmstruck_leavefactory.nextval from dual")
    BigDecimal selectMaxId();

    //查询采购所有的出厂实绩、
    List<Map<String, Object>> getCGLeaveFactoryResult(Map<String, Object> map);

    //查询运输路线是否为出厂
    Integer selectTransportRoute(String orderNumber);

    //查询车牌号与门岗
    Map<String,Object> selectCnAndGnByOrderNumber(String orderNumber);

    //根据订单号获取实绩id
    Map<String, Object> selectResultId(String orderNumber);

    //销售物流查询所有的出厂实绩
    List<Map<String,Object>> selectAllLeaveFacatoryForSale(Map<String,Object> map);

    //查询内转钢材到异地库出厂实绩
    List<Map<String, Object>> selectSteelNzLeaveFactory(Map<String, Object> map);

    //查询内转国产矿进口矿出厂实绩
    List<Map<String, Object>> getImportedDomesticNzEnFactoryResult(Map<String, Object> map);

    //查询内转厂内物资出厂实绩
    List<Map<String, Object>> getInFactoryOutFactoryResult(Map<String, Object> map);

    //通过总实绩Id查询出厂实绩
    BigDecimal getResultIdByTotalId(Integer resultTotalId);

    Map<String, Object> getTruckFactoryResult(String nu);

    //
    List<Map<String, Object>> getLeaveFactoryList(String orderNumber);


    Map<String, Object> getDeliveryOrder(String orderNumber);

    List<Map<String,Object>> getDeliveryOrderMaterial(String orderNumber);

    // 查询零星物资出厂列表
    List<Map<String,Object>> getSporadicLeaveFactory(Map<String, Object> mapValue);

    //根据采购订单ID查询是否为一车多趟
    Integer getIsMoreTripsStatus(BigDecimal orderId);

    int getPlanEnable(BigDecimal orderId);

    Integer getSeq(BigDecimal orderId);

}