package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckTimeTaskResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckTimeTaskResultMapper extends IBaseMapper<TmstruckTimeTaskResult, BigDecimal> {

    //查询最大ID
    @Select("select seq_time_task.nextval from dual")
    BigDecimal selectMaxId();

    //通过运输订单号 查询总实绩ID
    Map<String, Object> getResultTotalIdByOrderNum(String orderNumber);

    //查询上一次用车单位确认暂停结束时间
    Map<String, Object> getLastTimeout(BigDecimal resultTotalId);

    //查询用车单位确认开始时间
    Map<String, Object> getStartTime(BigDecimal resultTotalId);

    //查询所有确认暂停结束时间
    List<Map<String, Object>> getAllTimeout(BigDecimal resultTotalId);

    //查询计时作业
    List<Map<String, Object>> getAllTimeTaskResult(Map<String, Object> map);

}