package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckUnloadResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckUnloadResultMapper extends IBaseMapper<TmstruckUnloadResult, BigDecimal> {
    //查询采购卸货实绩
    List<Map<String, Object>> getCGUnloadResult(Map<String, Object> map);

    //查询内转采购进口矿国产矿卸货实绩
    List<Map<String, Object>> getImportedDomesticNzUnloadResult(Map<String, Object> map);

    //查询内转采购进口矿国产矿卸货实绩(老区-厂内)
    List<Map<String, Object>> getImportedDomesticNzUnload2Result(Map<String, Object> map);

    //查询内转厂内卸货实绩
    List<Map<String, Object>> getInFactoryUnloadResult(Map<String, Object> map);

    //查询最大ID值
    @Select("select seq_tmstruck_unload_result.nextval from dual")
    BigDecimal selectMaxId();

    // 通过总实绩id查询卸货实绩id
    BigDecimal getResultIdByTotalId(BigDecimal totalId);

    //通过运输订单号查询 实绩Id 和总实绩Id
    Map<String, Object> selectTotalIdByOrderNo(String orderNumber);

    //通过卸货地点查询仓库Id
    BigDecimal getWarehouseIdByWName(String warehouseName);

    //根据运输订单号查找装车实绩
    Map<String,Object> selectUnloadResultIdByOrderNumber(String orderNumber);

    //通过总实绩ID查询卸货点
    BigDecimal getUnloadPointId(Map<String, Object> map);

    // 通过运输订单id查询卸车实绩(零星物资）
    List<Map<String, Object>> getSporadicSuppliesUnloadResult(Map<String, Object> map);

    //根据运输订单号查询物资id优先级
     List<Map<String,Object>>  selectMaterialForUnload(String orderNumber);

     //查询物资是否被计量(map:orderNumber,MaterialId)
    Integer selectUnloadMaterialId(Map<String,Object> map);

    Map<String,Object> selectOrderId(Map<String, Object> map);

    //根据总实绩ID查询是否有净重
    Integer getNetWeightByTotalId(BigDecimal totalId);
}