package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="计时作业实绩表")
public class TmstruckTimeTaskResult implements IBasePO<BigDecimal> {
    /**
     * 主键id(TIME_TASK_RESULT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键id",required=true)
    private BigDecimal timeTaskResultId;

    /**
     * 总实绩ID(RESULT_TOTAL_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="总实绩ID",required=false)
    private BigDecimal resultTotalId;

    /**
     * 作业时长(RESULT_VALUE,DECIMAL,10)
     */
    @ApiModelProperty(value="作业时长",required=false)
    private BigDecimal resultValue;

    /**
     * 度量单位ID(RESULT_UOM_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="度量单位ID",required=false)
    private BigDecimal resultUomId;

    /**
     * 记录时间类型：（0：计时开始申请时间；1：计时开始确认时间；2：计时结束申请时间；3：计时结束确认时间；4：暂停开始申请时间；5：暂停开始确认时间；6：暂停结束申请时间；7：暂停结束确认时间）(RESULT_TIME_TYPE,DECIMAL,38)
     */
    @ApiModelProperty(value="记录时间类型：（0：计时开始申请时间；1：计时开始确认时间；2：计时结束申请时间；3：计时结束确认时间；4：暂停开始申请时间；5：暂停开始确认时间；6：暂停结束申请时间；7：暂停结束确认时间）",required=false)
    private BigDecimal resultTimeType;

    /**
     * 计时时间(RESULT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="计时时间",required=false)
    private Date resultTime;

    /**
     * 扫码开始作业点ID(RESULT_START_NODE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="扫码开始作业点ID",required=false)
    private BigDecimal resultStartNodeId;

    /**
     * 扫码开始经度(RESULT_START_LONGITUDE_VAL,VARCHAR,20)
     */
    @ApiModelProperty(value="扫码开始经度",required=false)
    private String resultStartLongitudeVal;

    /**
     * 扫码开始纬度(RESULT_START_LATITUDE_VAL,VARCHAR,20)
     */
    @ApiModelProperty(value="扫码开始纬度",required=false)
    private String resultStartLatitudeVal;

    /**
     * 扫码结束作业点ID(RESULT_END_NODE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="扫码结束作业点ID",required=false)
    private BigDecimal resultEndNodeId;

    /**
     * 扫码结束经度(RESULT_END_LONGITUDE_VAL,VARCHAR,20)
     */
    @ApiModelProperty(value="扫码结束经度",required=false)
    private String resultEndLongitudeVal;

    /**
     * 扫码结束纬度(RESULT_END_LATITUDE_VAL,VARCHAR,20)
     */
    @ApiModelProperty(value="扫码结束纬度",required=false)
    private String resultEndLatitudeVal;

    /**
     * 备注(RESULT_MEMO,VARCHAR,200)
     */
    @ApiModelProperty(value="备注",required=false)
    private String resultMemo;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 废除人(DELETE_NAME,VARCHAR,20)
     */
    @ApiModelProperty(value="废除人",required=false)
    private String deleteName;

    /**
     * 废除时间(DELETE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="废除时间",required=false)
    private Date deleteTime;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.timeTaskResultId;
    }

    @Override
    public void setId(BigDecimal timeTaskResultId) {
        this.timeTaskResultId = timeTaskResultId;
    }

    public BigDecimal getTimeTaskResultId() {
        return timeTaskResultId;
    }

    public void setTimeTaskResultId(BigDecimal timeTaskResultId) {
        this.timeTaskResultId = timeTaskResultId;
    }

    public BigDecimal getResultTotalId() {
        return resultTotalId;
    }

    public void setResultTotalId(BigDecimal resultTotalId) {
        this.resultTotalId = resultTotalId;
    }

    public BigDecimal getResultValue() {
        return resultValue;
    }

    public void setResultValue(BigDecimal resultValue) {
        this.resultValue = resultValue;
    }

    public BigDecimal getResultUomId() {
        return resultUomId;
    }

    public void setResultUomId(BigDecimal resultUomId) {
        this.resultUomId = resultUomId;
    }

    public BigDecimal getResultTimeType() {
        return resultTimeType;
    }

    public void setResultTimeType(BigDecimal resultTimeType) {
        this.resultTimeType = resultTimeType;
    }

    public Date getResultTime() {
        return resultTime;
    }

    public void setResultTime(Date resultTime) {
        this.resultTime = resultTime;
    }

    public BigDecimal getResultStartNodeId() {
        return resultStartNodeId;
    }

    public void setResultStartNodeId(BigDecimal resultStartNodeId) {
        this.resultStartNodeId = resultStartNodeId;
    }

    public String getResultStartLongitudeVal() {
        return resultStartLongitudeVal;
    }

    public void setResultStartLongitudeVal(String resultStartLongitudeVal) {
        this.resultStartLongitudeVal = resultStartLongitudeVal == null ? null : resultStartLongitudeVal.trim();
    }

    public String getResultStartLatitudeVal() {
        return resultStartLatitudeVal;
    }

    public void setResultStartLatitudeVal(String resultStartLatitudeVal) {
        this.resultStartLatitudeVal = resultStartLatitudeVal == null ? null : resultStartLatitudeVal.trim();
    }

    public BigDecimal getResultEndNodeId() {
        return resultEndNodeId;
    }

    public void setResultEndNodeId(BigDecimal resultEndNodeId) {
        this.resultEndNodeId = resultEndNodeId;
    }

    public String getResultEndLongitudeVal() {
        return resultEndLongitudeVal;
    }

    public void setResultEndLongitudeVal(String resultEndLongitudeVal) {
        this.resultEndLongitudeVal = resultEndLongitudeVal == null ? null : resultEndLongitudeVal.trim();
    }

    public String getResultEndLatitudeVal() {
        return resultEndLatitudeVal;
    }

    public void setResultEndLatitudeVal(String resultEndLatitudeVal) {
        this.resultEndLatitudeVal = resultEndLatitudeVal == null ? null : resultEndLatitudeVal.trim();
    }

    public String getResultMemo() {
        return resultMemo;
    }

    public void setResultMemo(String resultMemo) {
        this.resultMemo = resultMemo == null ? null : resultMemo.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public String getDeleteName() {
        return deleteName;
    }

    public void setDeleteName(String deleteName) {
        this.deleteName = deleteName == null ? null : deleteName.trim();
    }

    public Date getDeleteTime() {
        return deleteTime;
    }

    public void setDeleteTime(Date deleteTime) {
        this.deleteTime = deleteTime;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", timeTaskResultId=").append(timeTaskResultId);
        sb.append(", resultTotalId=").append(resultTotalId);
        sb.append(", resultValue=").append(resultValue);
        sb.append(", resultUomId=").append(resultUomId);
        sb.append(", resultTimeType=").append(resultTimeType);
        sb.append(", resultTime=").append(resultTime);
        sb.append(", resultStartNodeId=").append(resultStartNodeId);
        sb.append(", resultStartLongitudeVal=").append(resultStartLongitudeVal);
        sb.append(", resultStartLatitudeVal=").append(resultStartLatitudeVal);
        sb.append(", resultEndNodeId=").append(resultEndNodeId);
        sb.append(", resultEndLongitudeVal=").append(resultEndLongitudeVal);
        sb.append(", resultEndLatitudeVal=").append(resultEndLatitudeVal);
        sb.append(", resultMemo=").append(resultMemo);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleteName=").append(deleteName);
        sb.append(", deleteTime=").append(deleteTime);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}