package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.TmstruckEnfactoryResultMapper;
import com.steerinfo.dil.mapper.TmstruckLeaveFactoryResultMapper;
import com.steerinfo.dil.service.ITmstruckSelfMachineService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author luobang
 * @create 2021-11-17 20:59
 */
@Service
public class TmstruckSelfMachineService implements ITmstruckSelfMachineService {

    @Autowired
    TmstruckEnfactoryResultMapper tmstruckEnfactoryResultMapper;

    @Autowired
    TmstruckLeaveFactoryResultMapper tmstruckLeaveFactoryResultMapper;

    /**
     * 提货单信息
     * @param orderNumber
     * @return
     */
    @Override
    public Map<String, Object> getBillOrder(String orderNumber) {

        //1.根据运输订单号查询主干信息

        Map<String,Object>map=tmstruckEnfactoryResultMapper.getBillOrder(orderNumber);

        //2.根据运输订单号查询枝叶信息-物资

        List<Map<String,Object>>list=tmstruckEnfactoryResultMapper.getBillOrderMaterial(orderNumber);
        map.put("materialList",list);
        return map;
    }

    @Override
    public Map<String, Object> getDeliveryOrder(String orderNumber) {
        Map<String,Object> map = tmstruckLeaveFactoryResultMapper.getDeliveryOrder(orderNumber);
        List<Map<String, Object>> deliveryOrderMaterialList = tmstruckLeaveFactoryResultMapper.getDeliveryOrderMaterial(orderNumber);
        map.put("deliveryOrderMaterialList",deliveryOrderMaterialList);
        return map;
    }
}
