package com.steerinfo.route.config;

import com.alibaba.fastjson.JSON;
import com.steerinfo.route.threeRequest.ZhongJiaoXingLu;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.listener.KeyExpirationEventMessageListener;
import org.springframework.data.redis.listener.RedisMessageListenerContainer;

import java.util.Calendar;
import java.util.HashMap;
import java.util.concurrent.TimeUnit;

@Api("redis过期的监听")
public class KeyExpiredListener extends KeyExpirationEventMessageListener
{
    @Value("${redis.prefix.order}")
    private String prefixOrder;
    @Value("${redis.prefix.line}")
    private String prefixLine;
    @Value("${redis.prefix.suffix}")
    private String suffix;
    @Autowired
    private RedisTemplate redisTemplate;
    @Autowired
    private ZhongJiaoXingLu zhongJiaoXingLu;
    public KeyExpiredListener(RedisMessageListenerContainer listenerContainer)
    {
        super(listenerContainer);
    }
    @Override
    public void onMessage(Message message, byte[] pattern)
    {
        //当订单快超过三天，这边就要对路径进行保存了
        if (message.toString().startsWith(prefixOrder)){
            String redisJson = (String) redisTemplate.opsForValue().get(message.toString()+suffix);
            redisTemplate.delete(message.toString()+suffix);
            HashMap mapValue = JSON.parseObject(redisJson, HashMap.class);
            String json = zhongJiaoXingLu.visualRoute(mapValue);
            //设置60天后过期
            Calendar calendar= Calendar.getInstance();
            long agoTime= calendar.getTime().getTime();
            calendar.add(Calendar.MONTH,2);
            long lateTime= calendar.getTime().getTime();
            long saveTime=(lateTime-agoTime)/1000;
            String orderId=message.toString().replace(prefixOrder+":","");
            if (json!=null){
                redisTemplate.opsForValue().set(prefixLine+":"+orderId, json, saveTime, TimeUnit.SECONDS);
            }

        }
    }
}