package com.steerinfo.route.threeRequest;

import com.alibaba.fastjson.JSONObject;
import com.openapi.sdk.service.DataExchangeService;
import com.steerinfo.route.util.DataConversionTool;
import com.steerinfo.route.util.LngLonUtil;
import com.steerinfo.route.vo.FullPathVisualizationTo.ViewVisualization;
import com.steerinfo.route.vo.Map.Point;
import com.steerinfo.route.vo.Map.RouteVo;
import com.steerinfo.route.vo.Map.StartAndEndRoute;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.CompletableFuture;
import java.util.stream.Collectors;

@Component
public class ZhongJiaoXingLu {


    @Value("${str.ZhongJiaoXingLu.parkMins}")
    private String parkMins;
    @Value("${str.ZhongJiaoXingLu.abnMins}")
    private String abnMins;
    @Value("${str.ZhongJiaoXingLu.outMins}")
    private String outMins;
    @Value("${str.ZhongJiaoXingLu.type}")
    private String type;
    private String token="238684c3-1817-4e5e-8695-a8c85f8fd231";
    @Value("${str.ZhongJiaoXingLu.cid}")
    private String cid;
    @Value("${str.ZhongJiaoXingLu.srt}")
    private String srt;
    @Value("${str.ZhongJiaoXingLu.user}")
    private String user;
    @Value("${str.ZhongJiaoXingLu.pwd}")
    private String pwd;
    //"238684c3-1817-4e5e-8695-a8c85f8fd231"
    //"2667ca1f-e003-4822-b4c1-f25561c27f31"
    //"3dbdc182-b235-4c33-be30-88c0fe8999c5"
    public String visualRoute(HashMap routeMap) {
        try {
            //登陆之后返回的token:d21661ca-e0fe-4934-866a-7d78a0756bd4
            Map<String, String> map = new HashMap<String, String>(3);
            map.put("token", token);
            map.put("cid", cid);
            map.put("srt", srt);
            map.put("startLonlat", routeMap.get("startLonlat").toString());
            map.put("endLonlat", routeMap.get("endLonlat").toString());
            map.put("vclN", routeMap.get("vclN").toString());
            map.put("vco",routeMap.get("vco").toString());
            map.put("qryBtm", routeMap.get("qryBtm").toString());
            map.put("qryEtm", routeMap.get("qryEtm").toString());
            map.put("timeNearby", "30");
            String url = "https://openapi.sinoiov.cn/save/apis/visualRoute";
            DataExchangeService des = new DataExchangeService(5000, 8000);

            // 通过 https 方式调用，此方法内部会使用私钥生成签名参数 sign,私钥不会发送
            String res = des.postHttps(url, map);
            JSONObject jsonObject = JSONObject.parseObject(res);
            if (jsonObject.get("status").toString().equals(1016+"")){
                login();
                return visualRoute( routeMap);
            }
            return res;
        } catch (Exception e) {
            System.out.println("e:" + e.getMessage());
        }
        return null;
    }
    //String startLonlat,String endLonlat,String vclN,String vco,String qryBtm,String qryEtm
    public String subAbnormalLineWarnV2(HashMap routeMap ) {
        try {
            //登陆之后返回的token:d21661ca-e0fe-4934-866a-7d78a0756bd4
            Map<String, String> map = new HashMap<String, String>(3);
            map.put("token", token);
            map.put("cid", cid);
            map.put("srt", srt);
            map.put("vclN", routeMap.get("vclN").toString());
            map.put("vco","2");
            map.put("startCode", routeMap.get("startCode").toString());
            map.put("destCode", routeMap.get("destCode").toString());
            map.put("startCoor", routeMap.get("startLonlat").toString());
            map.put("destCoor", routeMap.get("endLonlat").toString());
            //把字符串转换成CST日期类型
            map.put("stime", cstToGMT(routeMap.get("qryBtm").toString()).toString());
            map.put("etime", cstToGMT(routeMap.get("qryEtm").toString()).toString());
            map.put("parkMins", parkMins);
            map.put("outMins", outMins);
            map.put("abnMins", abnMins);
            map.put("type", type);
            String url = "https://openapi.sinoiov.cn/save/apis/subAbnormalLineWarnV2";
            DataExchangeService des = new DataExchangeService(5000, 8000);

            // 通过 https 方式调用，此方法内部会使用私钥生成签名参数 sign,私钥不会发送
            System.out.println("map");
            System.out.println(map);
            String res = des.postHttps(url, map);
            System.out.println("res");
            System.out.println(res);
            JSONObject jsonObject = JSONObject.parseObject(res);
            if (jsonObject.get("status").toString().equals(1016+"")){
                login();
                return subAbnormalLineWarnV2(routeMap);
            }

            return res;
        } catch (Exception e) {
            System.out.println("e:" + e.getMessage());
        }
        return null;
    }

    public String cstToGMT(String data) throws InterruptedException, ParseException {

        SimpleDateFormat sdf1 = new SimpleDateFormat("EEE MMM dd HH:mm:ss zzz yyyy", Locale.US);
        SimpleDateFormat sdf = new SimpleDateFormat("EEE d MMM yyyy HH:mm:ss 'GMT'", Locale.US);
        sdf.setTimeZone(TimeZone.getTimeZone("GMT+8")); // 设置时区为GMT  +8为北京时间东八区
        String str = String.valueOf(sdf1.parse(data).getTime()-60000);
        return str;
    }
    public String netValidation(String vclN) {
        try {
            //登陆之后返回的token:d21661ca-e0fe-4934-866a-7d78a0756bd4
            Map<String, String> map = new HashMap<String, String>(4);
            map.put("token", token);
            map.put("cid", cid);
            map.put("srt", srt);
            map.put("vclN", vclN);
            String url = "https://openapi.sinoiov.cn/save/apis/checkTruckExist";
            DataExchangeService des = new DataExchangeService(5000, 8000);

            // 通过 https 方式调用，此方法内部会使用私钥生成签名参数 sign,私钥不会发送
            String res = des.postHttps(url, map);
            JSONObject jsonObject = JSONObject.parseObject(res);
            if (jsonObject.get("status").toString().equals(1016+"")){
                login();
                return netValidation(vclN);
            }
            return res;
        } catch (Exception e) {
            System.out.println("e:" + e.getMessage());
        }
        return null;
    }
    public  void login() {
        try {
            Map<String, String> map = new HashMap<String, String>(4);
            map.put("user", user);
            map.put("pwd", pwd);
            map.put("cid", cid);
            map.put("srt", srt);
            String url = "https://openapi.sinoiov.cn/save/apis/login/";
            DataExchangeService des = new DataExchangeService(5000, 8000);
            // 通过 https 方式调用，此方法内部会使用私钥生成签名参数 sign,私钥不会发送
            String res = des.postHttps(url, map);
            JSONObject jsonObject = JSONObject.parseObject(res);
            this.token=jsonObject.get("result").toString();
            //System.out.println("返回:"+ res);
        } catch (Exception e) {
            System.out.println("e:" + e.getMessage());
        }
    }
    public CompletableFuture<RouteVo> fullPathVisualization(String json) throws Exception {
        //初始开始链路和结束线路、开始点、结束点、当前点的集合
        List<StartAndEndRoute> startAndEndRouteList=new ArrayList<>();
        //一条路线，开始链路和结束线路、开始点、结束点、当前点
        StartAndEndRoute startAndEndRoute=new StartAndEndRoute();
        // String startLonlat,String endLonlat,String vclN,String vco,String qryBtm,String qryEtm
//        map.put("vclN", "陕YH0009");
//        map.put("vco","2");
//        map.put("qryBtm", "2021-10-06 22:10:10");
//        map.put("qryEtm", "2021-10-07 22:10:10");
        //String json =ZhongJiaoXingLu.visualRoute("","","陕YH0009","2","2021-10-06 22:10:10","2021-10-07 22:10:10");
        ViewVisualization to= (ViewVisualization) DataConversionTool.jsonToBean(json,ViewVisualization.class);
        //初始化vo对象
        RouteVo vo=new RouteVo();
        //当前所在的点
        if ((!StringUtils.isEmpty(to.getResult().getLat()))&& (!StringUtils.isEmpty(to.getResult().getLon()))){
            double[] centerpoint = LngLonUtil.gps84_To_Gcj02((Double.valueOf(to.getResult().getLat()) / 600000), (Double.valueOf(to.getResult().getLon()) / 600000));
            //当前所在的点
            Point currentPoint=new Point();
            currentPoint.setLat(centerpoint[0]+"");
            currentPoint.setLon(centerpoint[1]+"");
            startAndEndRoute.setCurrentPoint(currentPoint);
        }
        //当前所在地名称
        startAndEndRoute.setCurrentPointName(to.getResult().getAdr());
        //初始已行驶轨迹集合
        if (to.getResult().getRunRoute()!=null){
            List<Point> routes = to.getResult().getRunRoute().stream().map(item->{
                Point er=new Point();
                double[] points = LngLonUtil.gps84_To_Gcj02((Double.valueOf(item.getLat()) / 600000), (Double.valueOf(item.getLon()) / 600000));
                er.setLat(points[0]+"");
                er.setLon(points[1]+"");
                return  er;
            }).collect(Collectors.toList());
            //初始化起始点,已经经过路段的第一个点
            startAndEndRoute.setStartPoint(routes.get(0));
            //已经完成路线点集合
            startAndEndRoute.setRunRoute(routes);
        }
        //预估轨迹
        if (to.getResult().getEstimateRoute()!=null){
            List<Point> estimateRoute= to.getResult().getEstimateRoute().stream().map(item->{
                Point er=new Point();
                double[] points = LngLonUtil.gps84_To_Gcj02((Double.valueOf(item.getLat()) / 600000), (Double.valueOf(item.getLon()) / 600000));
                er.setLat(points[0]+"");
                er.setLon(points[1]+"");
                return  er;
            }).collect(Collectors.toList());
            //结束点
            startAndEndRoute.setEndPoint(estimateRoute.get(estimateRoute.size()-1));
            //预估轨迹赋值
            startAndEndRoute.setEstimateRoute(estimateRoute);
        }
        //当前所行驶历程数
        String mil=to.getResult().getRunRoute().get(to.getResult().getRunRoute().size()-1).getMil();
        startAndEndRoute.setMiled(mil);
        startAndEndRouteList.add(startAndEndRoute);
        vo.setStartAndEndRoutes(startAndEndRouteList);
        //
        //设置返回值对象
        return CompletableFuture.completedFuture(vo) ;
    }





    public String getCid() {
        return cid;
    }

    public  void setCid(String cid) {
        this.cid = cid;
    }

    public String getSrt() {
        return srt;
    }

    public  void setSrt(String srt) {
        this.srt = srt;
    }

    public String getUser() {
        return user;
    }

    public  void setUser(String user) {
        this.user = user;
    }

    public String getPwd() {
        return pwd;
    }

    public  void setPwd(String pwd) {
        this.pwd = pwd;
    }


}